\section{List of control parameters}\label{sec:controlpar}
The execution of \maphys{} can be controlled by the user through the 2 arrays \textbf{mphs\%ICNTL} and \textbf{mphs\%RCNTL}. When an execution control should be expressed as an integer (or an equivalent), this control is a entry of \textbf{mphs\%ICNTL}; and when an execution control should be expressed as a float (or an equivalent), this control is a entry of \textbf{mphs\%RCNTL}.
\subsection{ICNTL}
\textbf{mphs\%ICNTL} is an integer array of size \textbf{MAPHYS\_ICNTL\_SIZE}.
\begin{description}
\item [ICNTL(1)\label{itm:icntl1}]: Controls where are written error messages. Fortran unit used to write error messages. Negative value means do not print error messages.
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: ICNTL\_OUTPUT\_ErrUnit}}
}{}
\begin{description}
\item[Default]: 0 (stderr)
\end{description}
\item [ICNTL(2)\label{itm:icntl2}]: Controls where are written warning messages. Fortran unit used to write warning messages. Negative value means do not print warning messages.
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: ICNTL\_OUTPUT\_WarnUnit}}
}{}
\begin{description}
\item[Default]: 0 (stderr)
\end{description}
\item [ICNTL(3)\label{itm:icntl3}]: Controls where are written statistics messages. Fortran unit used to write statistics messages. Negative value means do not print statistics.
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: ICNTL\_OUTPUT\_StdUnit}}
}{}
\begin{description}
\item[Default]: 6 (stdout)
\end{description}
\item [ICNTL(4)\label{itm:icntl4}]: Controls where are written statistics messages. Fortran unit used to write statistics messages. Negative value means do not print statistics.
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: ICNTL\_OUTPUT\_Verbosity}}
}{}
\begin{description}
\item [1]: Print errors.
\item [2]: Print errors, warnings and main statistics.
\item [3]: print errors, warnings and several detailled statistics.
\item [4]: Print errors, warnings and verbose on detailled statistics.
\iftoggle{devversion}{
\textcolor{red}{
\item [$>5$]: Debug level.
\item [5]: Print errors, warnings and very verbose on detailled statistics.
}
}{}
\item[Default]: 3
\end{description}
\item [ICNTL(5)\label{itm:icntl5}]: Controls when to print list of controls (Xcntl). This option is useful to check if a control is taken into account.
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: ICNTL\_PRINT\_Cntls}}
}{}
\begin{description}
\item [0]: Never print.
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: PRINT\_Not}}
}{}
\item [1]: Print once at the begining of analysis.
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: PRINT\_Once}}
}{}
\item [2]: Print at the begining of each step.
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: PRINT\_EveryStep}}
}{}
\item[Default]: 0
\end{description}
\item [ICNTL(6)\label{itm:icntl6}]: Controls when to print list of informations (Xinfo). This option is useful while performing benchmarks.
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: ICNTL\_PRINT\_Infos}}
}{}
\begin{description}
\item [0]: Never print.
\item [1]: Print once at the begining of analysis.
\item [2]: Print at the begining of each step.
\item[Default]: 0
\end{description}
\iftoggle{devversion}{
\textcolor{red}{
\item [ICNTL(7)\label{itm:icntl7}]: Controls the partitioner strategy. It is only accessed by MPI process, during the analysis step.  It is only useful while using a centralized input system (\ref{itm:icntl43}). See also: \ref{itm:icntl43} (centralized or distributed input system).
\\ \textbf{Warning: Metis is an experimental method, if you choose this option you cannot be sure that the program will run correctly.}
\\ \*\emph{Enumeration: ICNTL\_PART\_Strategy}\begin{description}
\item [1-3]: Nested Dissection on Nodes with METIS.
\item [4]: Nested Dissection on Nodes with SCOTCH.
\\ \*\emph{Enumeration: PART\_STRATEGY\_isScotchNodeND}\item[Default]: 4
\end{description}
}
}{}
\item [ICNTL(8)\label{itm:icntl8}]: Controls the Partial ILUT solver. level of filling for L and U in the ILUT method. ( that is the maximun number of entries per row in the LU factorization. ) This parameter is only relevant while using ILUT and is accessed during factorisation by each process. User must set this parameter while using ILUT before the factorisation. See also : \ref{itm:icntl30}, \ref{itm:icntl9}, \ref{itm:rcntl8} and \ref{itm:rcntl9}.
\\ \textbf{Warning: The default value is a bad value.}
\\ \textit{Note: For more details on ILU method, you may refer to Section \ref{sec:ilut}}
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: ICNTL\_ILU\_LUFill}}
}{}
\begin{description}
\item[Default]: -1
\end{description}
\item [ICNTL(9)\label{itm:icntl9}]: Controls the Partial ILUT solver. level of filling for the Schur complement in the ILUT method (that is the maximun number of entries per row in the Schur complement). This parameter is only relevant while using ILUT and is accessed during factorisation by each process. User must set this parameter while using ILUT before the factorisation. See also : \ref{itm:icntl30},\ref{itm:icntl8}, \ref{itm:rcntl8} and \ref{itm:rcntl9}.
\\ \textbf{Warning: The default value is a bad value.}
\\ \textit{Note: For more details on ILU method, you may refer to Section \ref{sec:ilut}}
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: ICNTL\_ILU\_SCHURFill}}
}{}
\begin{description}
\item[Default]: -1
\end{description}
\iftoggle{devversion}{
\textcolor{red}{
\item [ICNTL(10)\label{itm:icntl10}]: Level of filling for the ILU method, in percent. See also \ref{itm:icntl30}.
\\ \textbf{Warning: Not implemented.}
\\ \*\emph{Enumeration: ICNTL\_ILU\_LUFillPct}\begin{description}
\item[Default]: 0
\end{description}
}
}{}
\iftoggle{devversion}{
\textcolor{red}{
\item [ICNTL(11)\label{itm:icntl11}]: Level of filling for the approximate schur, in percent. (TODO) See also : \ref{itm:icntl30}.
\\ \textbf{Warning: Not implemented.}
\\ \*\emph{Enumeration: ICNTL\_ILU\_SCHURFillPct}\begin{description}
\item[Default]: 0
\end{description}
}
}{}
\iftoggle{devversion}{
\textcolor{red}{
\item [ICNTL(12)\label{itm:icntl12}]: Controls if the matrix needs to be shifted. It is only relevant on complex matrix.
\\ \textbf{Warning: Not implemented.}
\\ \*\emph{Enumeration: ICNTL\_SHIFT\_Do}\begin{description}
\item [0]: Do not shift
\item [1]: Read the shifted matrix for the input matrix. UNAVAILABLE.
\item [2]: Use an auto shifted matrix for the input matrix. UNAVAILABLE.
\item [3]: Shift the Schur complement matrix.
\item [4]: Shift the Schur complement matrix.
\item[Default]: 0
\end{description}
}
}{}
\item [ICNTL(13)\label{itm:icntl13}]: The sparse direct solver package to be used by MAPHYS. It is accessed during the factorization and the the preconditionning step by each MPI process. Default value the first available starting from index 1.
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: ICNTL\_SDS\_Default}}
}{}
\begin{description}
\item [1]: Use \mumps.
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: SDS\_DEFAULT\_Mumps}}
}{}
\item [2]: Use \pastix.
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: SDS\_DEFAULT\_Pastix}}
}{}
\item [3]: Use multiple sparse direct solvers. See \ref{itm:icntl15} and \ref{itm:icntl32}.
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: SDS\_DEFAULT\_UsrDefined}}
}{}
\item[Default]: 1
\end{description}
\item [ICNTL(14)\label{itm:icntl14}]: Output format.
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: ICNTL\_PRINT\_Format}}
}{}
\begin{description}
\item [0]: Standard output.
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: PRINT\_Standard}}
}{}
\item [1]: Emacs orgmode output.
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: PRINT\_Org}}
}{}
\item[Default]: 0
\end{description}
\item [ICNTL(15)\label{itm:icntl15}]: The sparse direct solver package to be used by MAPHYS for the computing the preconditioner. It is accessed during the preconditioning step, by each MPI process.
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: ICNTL\_SDS\_Precond}}
}{}
\begin{description}
\item [1]: Use \mumps.
\item [2]: Use \pastix.
\item[Default]: ICNTL(13)
\end{description}
\iftoggle{devversion}{
\textcolor{red}{
\item [ICNTL(19)\label{itm:icntl19}]: Which dense solver to use.
\\ \textbf{Warning: Chameleon not supported.}
\\ \*\emph{Enumeration: ICNTL\_DDS\_Precond}\begin{description}
\item [1]: LAPACK.
\\ \*\emph{Enumeration: DDS\_DEFAULT\_LAPACK}\item [2]: CHAMELEON.
\\ \*\emph{Enumeration: DDS\_DEFAULT\_CHAMELEON}\item[Default]: 1
\end{description}
}
}{}
\item [ICNTL(20)\label{itm:icntl20}]: Controls the 3rd party iterative solver to be used.
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: ICNTL\_ITS\_Solver}}
}{}
\begin{description}
\item [0]: Unset.
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: ITS\_Solver\_Unset}}
}{}
\item [1]: Use Pack GMRes.
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: ITS\_Solver\_isPackGMRES}}
}{}
\item [2]: Use Pack CG.
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: ITS\_Solver\_isPackCG}}
}{}
\item [3]: automatic selection. \begin{itemize}\item If mphs\%NRHS $>$ 1, use \fabulous \item If mphs\%NRHS = 1 and matrix is SPD, use Pack CG \item If mphs\%NRHS = 1 and matrix is not SPD, use Pack GMRes \end{itemize}
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: ITS\_Solver\_isAuto}}
}{}
\item [4]: Use Fabulous.
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: ITS\_Solver\_isFabulous}}
}{}
\item[Default]: 3
\end{description}
\item [ICNTL(21)\label{itm:icntl21}]: The strategy for preconditionning the Schur.
\\ \textbf{Warning: If (\ref{itm:icntl30}=2) and (\ref{itm:icntl21}/=4) then \ref{itm:icntl21} must be 3.}
\\ \textit{Note: For more details on dropping strategy (\ref{itm:icntl21} = 2 or 3), you may refer to Section 2.2, the parameter \ref{itm:rcntl8}/\ref{itm:rcntl9} if \ref{itm:icntl21}=2/3 respectively}
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: ICNTL\_PCD\_Strategy}}
}{}
\begin{description}
\item [1]: Preconditioner is the dense factorization of the assembled local schur.
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: PCD\_STRATEGY\_isLocalExact}}
}{}
\item [2]: Preconditioner is the sparse factorization of the assembled local schur, you have to specify the threshold using \ref{itm:rcntl11}.
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: PCD\_STRATEGY\_isLocalApprox}}
}{}
\item [3]: Preconditioner is the factorization of a sparse matrix. Where the sparse matrix is the assembly of the approximated local schur computed with the Partial Incomplete LU (PILUT), you have to specify the threshold using \ref{itm:rcntl9}.
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: PCD\_STRATEGY\_isForcedByILUT}}
}{}
\item [4]: No preconditioner.
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: PCD\_STRATEGY\_isNone}}
}{}
\item [5]: Autodetect, order of preferences is $1 > 2 > 3 > 4$.
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: PCD\_STRATEGY\_isAutodetected}}
}{}
\item [10]: Preconditioner is the dense factorization of the assembled local schur with additive coarse grid correction. You have to set the number of of eigenvalues per subdomain to keep with \ref{itm:icntl33}.
\\ \textbf{Warning: Only works for a symmetric positive definite matrix (mphs\%SYM = 1). \mumps is required to use this preconditioner.}
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: PCD\_STRATEGY\_isLocalExactWithCGC}}
}{}
\iftoggle{devversion}{
\textcolor{red}{
\item [6]: Preconditioner is the sparse factorization of the global schur.
\\ \*\emph{Enumeration: PCD\_STRATEGY\_isGlobalApprox}\item [7]: Preconditioner is the addition of the sparse factorization of the global schur and the sparse factorization of the assembled local schur.
\\ \*\emph{Enumeration: PCD\_STRATEGY\_isGlobalLocalApprox}}
}{}
\item[Default]: 2
\end{description}
\item [ICNTL(22)\label{itm:icntl22}]: Controls the iterative solver. (ex : PackGMRES package, it is : gmicntl(5)). Determines which orthogonalisation scheme to apply.
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: ICNTL\_ITS\_OrtStrategy}}
}{}
\begin{description}
\item [0]: Modified Gram-Schmidt orthogonalization (MGS).
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: ORT\_STRATEGY\_IsMGS}}
}{}
\item [1]: Iterative selective modified Gram-Schmidt orthogonalization (IMGS).
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: ORT\_STRATEGY\_IsIMGS}}
}{}
\item [2]: Classical Gram-Schmidt orthogonalization (CGS)
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: ORT\_STRATEGY\_IsCGS}}
}{}
\item [3]: Iterative classical Gram-Schmidt orthogonalisation (ICGS)
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: ORT\_STRATEGY\_IsICGS}}
}{}
\iftoggle{devversion}{
\textcolor{red}{
}
}{}
\item[Default]: 3
\end{description}
\item [ICNTL(23)\label{itm:icntl23}]: Controls the iterative solver. (ex : in PackGMRES package, it is : gmicntl(6)). Controls whether the user wishes to supply an initial guess of solution vector in (mphs\%SOL). It must equal to 0 or 1. It is accessed by all processes during the solve step.
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: ICNTL\_ITS\_InitGuess}}
}{}
\begin{description}
\item [0]: No initial guess (start with null vector).
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: INIT\_GUESS\_isUnset}}
}{}
\item [1]: User defined initial guess.
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: INIT\_GUESS\_isSet}}
}{}
\iftoggle{devversion}{
\textcolor{red}{
}
}{}
\item[Default]: 0
\end{description}
\item [ICNTL(24)\label{itm:icntl24}]: Controls the iterative solver. It define the maximum number of iterations (cumulated over restarts) allowed. It must be equal or larger than 0 and be the same on each process. 0 is the unset value, \maphys will perform 100 iterations. (Ex: in PackGMRES package, it is gmicntl(7)).
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: ICNTL\_ITS\_MaxIters}}
}{}
\begin{description}
\item[Default]: 100
\end{description}
\item [ICNTL(25)\label{itm:icntl25}]: Controls the iterative solver. Controls the strategy to compute the residual at the restart, it must be the same on each process. It is irrelevant while the iterative solver is CG (\ref{itm:icntl20} = 2,3). (Ex : in PackGMRES package, it is: gmicntl(8)).
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: ICNTL\_ITS\_ResStrategy}}
}{}
\begin{description}
\item [0]: A recurrence formula is used to compute the residual at each restart, except if the convergence was detected using the Arnoldi residual during the previous restart.
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: RES\_STRATEGY\_isRecurrence}}
}{}
\item [1]: The residual is explicitly computed using a matrix vector product.
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: RES\_STRATEGY\_isMatVectProduct}}
}{}
\iftoggle{devversion}{
\textcolor{red}{
}
}{}
\item[Default]: 0
\end{description}
\item [ICNTL(26)\label{itm:icntl26}]: Controls the iterative solver, it is the restart parameter of GMRES or \fabulous. It corresponds to the maximum size of the search space used. If mphs\%NRHS = 1, it is equal to the number of iterations between each restart. Ignored if the iterative solver is CG (\ref{itm:icntl20} = 2,3 with SPD matrix). 0 is the unset value, restart will be set at 100.
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: ICNTL\_ITS\_Restart}}
}{}
\begin{description}
\item[Default]: 100
\end{description}
\item [ICNTL(27)\label{itm:icntl27}]: Controls the iterative solver, it is the method used to perform multiplication between the Schur complement matrix and a vector. It should be set before the solving step on each process. It can be set on each process before the preconditioning step to allow possible memory footprint reduction (peak and usage)
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: ICNTL\_ITS\_MatVect}}
}{}
\begin{description}
\item [0]: Automatic (1 if possible, 2 if not).
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: MAT\_VECT\_isAutodetected}}
}{}
\item [1]: Product of schur complement with a vector is performed explicitly. That is, the Schur complement is stored in a dense matrix, and a BLAS routine is called to perform the product.
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: MAT\_VECT\_isExplicit}}
}{}
\item [2]: Product of schur complement with a vector is performed implicitly. That is, we do not use a schur complement stored in a dense matrix, to perform the product. Indeed, a ``solve' and several sparse matrix/vector products are used to perform the product. This is done by using the definition schur complement, which is : $S = A_{i,\Gamma} . A_{i,i}^{-1} . A_{i,\Gamma} - A_{\Gamma,\Gamma}$. This option reduce the memory footprint by substituing in memory the schur complement by the preconditioner.
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: MAT\_VECT\_isImplicit}}
}{}
\iftoggle{devversion}{
\textcolor{red}{
}
}{}
\item[Default]: 0
\end{description}
\item [ICNTL(28)\label{itm:icntl28}]: Controls the iterative solver. Control whether the scaled residual is computed with $\frac{|| A.x - b ||_2}{ ||b||_2}$ or $\frac{|| A.x - b ||_2}{ ||b_{\Gamma}||_2}$, where $||.||_2$ is the euclidean norm, $A$ the input matrix, $x$ the computed solution, $b$ the global right-hand-side and $b_{\Gamma}$ the right-hand-side restricted to the Schur complement. It must equal be to 0 or 1. It is accessed by all processes during the solve step.
\\ \textit{Note: Note that this choice impacts both the stopping criterion $\frac{|| A.x - b ||_2}{ ||b_{\Gamma}||_2 } < \tau $ within the iterative solve step (gmrcntl(3) and gmrntl(5) within packgmres, cgrcntl(3) within packcg) and the final computation of the residual (see \ref{itm:rinfog2} and \ref{itm:rinfog4}).}
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: ICNTL\_ITS\_ResNorm}}
}{}
\begin{description}
\item [0]: Compute the normalized residual with $\frac{|| A.x - b ||_2}{ ||b_{\Gamma}||_2}$.
\item [1]: Compute the normalized residual with $\frac{|| A.x - b ||_2}{ ||b||_2}$.
\item [2]: Compute the normalized residual with $\frac{|| A.x - b ||_2}{\alpha ||x||_2 + \beta}$ , where $\alpha$ and $\beta$ are chosen by the user with \ref{itm:rcntl3} and \ref{itm:rcntl4} respectively.
\\ \textbf{Warning: Not available with \fabulous}
\item[Default]: 1
\end{description}
\item [ICNTL(29)\label{itm:icntl29}]: Controls the mode of the iterative solver \fabulous (see \ref{itm:icntl20}).
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: ICNTL\_ITS\_FabulousMode}}
}{}
\begin{description}
\item [0]: Use standard Block GMRes algorithm.
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: FABULOUS\_ALGO\_STD}}
}{}
\item [1]: Use Block GMRes algorithm with detection of Inexact Breakdowns.
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: FABULOUS\_ALGO\_IB}}
}{}
\item [2]: Use Block GMRes algorithm with incremental QR.
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: FABULOUS\_ALGO\_QR}}
}{}
\item [3]: Use Block GMRes algorithm with Deflated Restart. See \ref{itm:icntl48} and \ref{itm:rcntl2} to control this option.
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: FABULOUS\_ALGO\_DR}}
}{}
\item [4]: Use BGMRES with Inexact Breakdowns and Deflated Restart. See \ref{itm:icntl48} and \ref{itm:rcntl2} to control this option.
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: FABULOUS\_ALGO\_IBDR}}
}{}
\item [5]: Use BGMRES with Incremental QR and Inexact Breakdowns.
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: FABULOUS\_ALGO\_QRIB}}
}{}
\item [6]: Use BGMRES with Incremental QR and deflated restarting. See \ref{itm:icntl48} and \ref{itm:rcntl2} to control this option.
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: FABULOUS\_ALGO\_QRDR}}
}{}
\item [7]: Use BGMRES with Incremental QR, Inexact Breakdowns and deflated restarting. See \ref{itm:icntl48} and \ref{itm:rcntl2} to control this option.
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: FABULOUS\_ALGO\_QRIBDR}}
}{}
\item [8]: Use BGCR (Block General Conjugate Residual).
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: FABULOUS\_ALGO\_GCR}}
}{}
\item[Default]: 1
\end{description}
\item [ICNTL(30)\label{itm:icntl30}]: Controls how to compute the schur complement matrix or its approximation. It is accessed during the factorisation step by each process. Each processor must have the same value (current version do not check it).
\\ \textit{Note: For more details on exact and approximated Schur, you may refer to Section \ref{subsec:implementation}.}
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: ICNTL\_SCHUR\_Strategy}}
}{}
\begin{description}
\item [0]: Use the schur complement returned by the sparse direct solver package.
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: SCHUR\_STRATEGY\_Exact}}
}{}
\item [2]: Approximate computation done using a modifyied version of partial ILUT (PILUT). In this case, user must set \ref{itm:icntl8}, \ref{itm:icntl9}, \ref{itm:rcntl8} and \ref{itm:rcntl9} the parameters of PILUT. This option force the preconditioner choice (\ref{itm:icntl21} = 3).
\\ \textit{Note: For more details on ILU method, you may refer to Section \ref{sec:ilut}.}
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: SCHUR\_STRATEGY\_ApprxWithIluT}}
}{}
\iftoggle{devversion}{
\textcolor{red}{
\item [1]: Compute it from its formal expression $S = Abi.Aii^{-1}.Aib $. The schur is exact, this is backend solution while 0 is not available, poor performance are expected. See also \ref{itm:icntl31}.
\\ \textbf{Warning: Not implemented.}
\\ \*\emph{Enumeration: SCHUR\_STRATEGY\_ExactFromFacto}}
}{}
\item[Default]: 0
\end{description}
\iftoggle{devversion}{
\textcolor{red}{
\item [ICNTL(31)\label{itm:icntl31}]: Advanced control of schur computation when \ref{itm:icntl30} = 1. In this case, the matrix vector operations, are done by blocks of rows or columns $\times$ \ref{itm:icntl31} specifies the size of these blocs.
\\ \textbf{Warning: Not implemented.}
\\ \*\emph{Enumeration: ICNTL\_EXSCHUR\_BlockSize}\begin{description}
\item[Default]: 50
\end{description}
}
}{}
\item [ICNTL(32)\label{itm:icntl32}]: The sparse direct solver package to be used by \maphys for the computing the local schur and perform the local factorisation. It is accessed during the factorization step, by each MPI process.
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: ICNTL\_SDS\_Facto}}
}{}
\begin{description}
\item [1]: Use \mumps.
\item [2]: Use \pastix.
\item[Default]: ICNTL(13)
\end{description}
\item [ICNTL(33)\label{itm:icntl33}]: Number of eigenvalues per subdomain to keep for the coarse grid correction. Ignored if \ref{itm:icntl21} $\ne$ 10.
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: ICNTL\_CGC\_Kvp}}
}{}
\begin{description}
\item[Default]: 10
\end{description}
\item [ICNTL(34)\label{itm:icntl34}]: Controls if the convergence history of the iterative solver is written in a file or treated as regular output.
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: ICNTL\_ITS\_Output}}
}{}
\begin{description}
\item [0]: Convergence history is treated as regular output.
\item [1]: Convergence history is written in a file: for the $N^{th}$ call the the iterative solver, the file is named \textit{gmres\_cvg\_N.dat} or \textit{cg\_cvg\_N.dat}. For \fabulous, the minimal and maximal backward errors are given as well as the time to compute the iteration in a file named \textit{fab\_cvg\_N.dat}.
\item[Default]: 0
\end{description}
\item [ICNTL(36)\label{itm:icntl36}]: How to bind thread inside \maphys.
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: ICNTL\_2LVLS\_Bind}}
}{}
\begin{description}
\item [0]: Do not bind.
\item [1]: Thead to core bind.
\item [2]: Grouped bind.
\item[Default]: 2
\end{description}
\item [ICNTL(37)\label{itm:icntl37}]: In 2 level of parallelism version, specifies the number of nodes. It is only useful if \ref{itm:icntl42} $>$ 0.
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: ICNTL\_2LVLS\_NNodes}}
}{}
\begin{description}
\item[Default]: 0
\end{description}
\item [ICNTL(38)\label{itm:icntl38}]: In 2 level of parallelism version, specifies the number of cores per node. It is only useful if \ref{itm:icntl42} $>$ 0.
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: ICNTL\_2LVLS\_NcoresPerNode}}
}{}
\begin{description}
\item[Default]: 1
\end{description}
\item [ICNTL(39)\label{itm:icntl39}]: In 2 level of parallelism version, specifies the number of threads per domains. It is only useful if \ref{itm:icntl42} $>$ 0.
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: ICNTL\_2LVLS\_NThrdsPerProc}}
}{}
\begin{description}
\item[Default]: 1
\end{description}
\item [ICNTL(40)\label{itm:icntl40}]: In 2 level of parallelism version, specifies the number of domains. It is only useful if \ref{itm:icntl42} $>$ 0.
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: ICNTL\_2LVLS\_NProcs}}
}{}
\begin{description}
\item[Default]: 1
\end{description}
\iftoggle{devversion}{
\textcolor{red}{
\item [ICNTL(41)\label{itm:icntl41}]: Use custom boundary conditions to assemble the Schur. Set to 1 to activte this option. The boundary conditions are given in a sparse matrix in the structure mphs\%bc.
\\ \*\emph{Enumeration: ICNTL\_CUSTOM\_BC}\begin{description}
\item[Default]: 0
\end{description}
}
}{}
\item [ICNTL(42)\label{itm:icntl42}]: Is the control paramater that activates the second level of parallelism version.
\\ \textit{Note: If the second level of parallelism is activated you have to set the parameters \ref{itm:icntl36}, \ref{itm:icntl37}, \ref{itm:icntl38}, \ref{itm:icntl39} and \ref{itm:icntl40}.}
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: ICNTL\_MAPHYSTHREAD}}
}{}
\begin{description}
\item [0]: Only MPI will be used.
\item [1]: Activate the multithreading on top of MPI.
\item[Default]: 0
\end{description}
\item [ICNTL(43)\label{itm:icntl43}]: Specifies the input system (centralized on the host, distributed, ...).
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: ICNTL\_INSYSTEM}}
}{}
\begin{description}
\item [1]: The input system is centralized on host. The input matrix and the right-hand member are centralized on the host. User must provides the global system by setting on the host : \begin{itemize} \item the global matrix before the analysis step : (mphs\%rows,mphs\%cols, etc. ) \item the global right-hand side before the solve step : (mphs\%rhs) \end{itemize}
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: INSYSTEM\_IsCentralized}}
}{}
\item [2]: The input system is distributed. The input matrix and the right-hand side are distributed. User must provides on each MPI process the local system by setting : \begin{itemize} \item the local matrix before the analysis step : (mphs\%rows,mphs\%cols, etc. ) \item the local right-hand side before the solve step : (mphs\%rhs) \item the data distribution before the analysis step : mphs\%lc\_domain \end{itemize}.
\\ \textit{Note: With Paddle (if \ref{itm:icntl49} = 2): The input system is distributed in any way on the MPI processes, given into a global numbering.}
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: INSYSTEM\_IsDistributed}}
}{}
\iftoggle{devversion}{
\textcolor{red}{
\item [3]: The input system  is recovered from a former analysis dump. The files have to be named as follows: \begin{itemize} \item maphys\_local\_matrix\textbf{\%idom}.mtx for the matrices, \item maphys\_local\_domain\textbf{\%idom}.dom for the domains, \item and maphys\_local\_rhs\textbf{\%idom}.ijv for the rhs, \end{itemize} where \textbf{\%idom} denotes the domain ID.
\\ \textbf{Warning: The number of MPI processes on which the code is launched has to match the number of domains (\emph{i.e.} the number of different \textbf{\%idom}) of the former analysis dump.}
\\ \*\emph{Enumeration: INSYSTEM\_FromAnalysisDump}}
}{}
\item[Default]: 1
\end{description}
\item [ICNTL(44)\label{itm:icntl44}]: When activated, it means than you have to describe the permutation you want \maphys to use. (mphs\%perm and mphs\%size)
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: ICNTL\_Distribution}}
}{}
\begin{description}
\item [0]: Distribution is performed by \maphys.
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: DISTRIBUTION\_isUnset}}
}{}
\item [1]: Distribution is provided by the user as describe before.
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: DISTRIBUTION\_isProvided}}
}{}
\iftoggle{devversion}{
\textcolor{red}{
}
}{}
\item[Default]: 0
\end{description}
\item [ICNTL(45)\label{itm:icntl45}]: Controls the local output after analysis. If  set to 1, it allows to perform a  dump of the local matrices, rhs and domain data after analysis. The files will be outputed in the working directory (\emph{i.e. where the code is called}). This option is unactivated by default.
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: ICNTL\_DUMP\_ANALYSIS}}
}{}
\begin{description}
\item [0]: No analysis dump.
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: NO\_ANALYSIS\_DUMP}}
}{}
\item [1]: Dump matrices, rhs and domain data in files after analysis.
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: PERFORM\_ANALYSIS\_DUMP}}
}{}
\item[Default]: 0
\end{description}
\item [ICNTL(47)\label{itm:icntl47}]: Controls the \mumps instance. Corresponds to the ICNTL 14 of \mumps. According to \mumps documentation, it ``corresponds to the percentage increase in the estimated working space.". You may have to increase this value if the program crashes in \mumps. It must be a positive value.
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: ICNTL\_MUMPS\_IncreaseWS}}
}{}
\begin{description}
\item[Default]: 20
\end{description}
\item [ICNTL(48)\label{itm:icntl48}]: Controls \fabulous Deflated Restart algorithm. Corresponds to the number of eigen vectors to keep for the next restart. See \ref{itm:rcntl2} to set the target.
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: ICNTL\_FABULOUS\_DR\_nVect}}
}{}
\begin{description}
\item[Default]: 10
\end{description}
\item [ICNTL(49)\label{itm:icntl49}]: controls the choice of the domain decomposition library/algorithm.
\\ \textbf{Warning: Modifies the behavior of \ref{itm:icntl43}}
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: ICNTL\_DD}}
}{}
\begin{description}
\item [1]: \maphys internal algorithm
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: DD\_Maphys}}
}{}
\item [2]: Paddle external library
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: DD\_Paddle}}
}{}
\item[Default]: 1
\end{description}
\item [ICNTL(50)\label{itm:icntl50}]: When \mumps error indicates that requires more memory workspace, \maphys can increase the value of \mumps ICNTL 14 to allow more workspace and repeat the operation until \mumps runs. This parameter describes what strategy to adopt when such an error occurs. See \ref{itm:icntl47} to set the initial percentage of extra workspace to be used by \mumps.
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: ICNTL\_MUMPS\_IncreaseStrat}}
}{}
\begin{description}
\item [0]: The \mumps error is considered fatal.
\item [$>0$]: Each time the error occurs, this value is added to the extra workspace \ref{itm:icntl47}.
\item [-1]: Each time the error occurs, the extra workspace \ref{itm:icntl47} is multiplied by \ref{itm:rcntl5}.
\item[Default]: 0
\end{description}
\item [ICNTL(51)\label{itm:icntl51}]: Controls the strategy of the application of the coarse level preconditioner.
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: ICNTL\_CGC\_STRAT}}
}{}
\begin{description}
\item [0]: Use \mumps, distributed mode
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: CGC\_STRAT\_SparseDist}}
}{}
\item [1]: Use \lapack, sequential only
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: CGC\_STRAT\_DenseCentralized}}
}{}
\item [2]: Use \ref{itm:icntl13} sparse direct solver with \ref{itm:icntl52} processes
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: CGC\_STRAT\_SparseCentralized}}
}{}
\item [3]: Duplicate coarse problem on groups of MPI processes with \ref{itm:icntl52} processes per group
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: CGC\_STRAT\_SparseReplicatedCentr}}
}{}
\item [4]: Make groups of \ref{itm:icntl52} processes, centralize the problem on each group master and compute the coarse grid with a distributed sparse direct solver on these masters
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: CGC\_STRAT\_SparseHierachicalDist}}
}{}
\item[Default]: 2
\end{description}
\item [ICNTL(52)\label{itm:icntl52}]: Corresponds to the number of MPI processes in use to compute and apply the 2-level coarse preconditioner from a centralized input with a sparse direct solver. Only in use with \ref{itm:icntl51} = 2, 3 or 4
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: ICNTL\_CGC\_NPROCS}}
}{}
\begin{description}
\item[Default]: 1
\end{description}
\item [ICNTL(55)\label{itm:icntl55}]: Orthogonalization is either vector-by-vector (RUHE) or block-by-block (BLOCK)
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: ICNTL\_FABULOUS\_OrthoType}}
}{}
\begin{description}
\item [0]: Orthogonalize vector one-by-one (RUHE variant)
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: ORT\_FABULOUS\_RUHE}}
}{}
\item [1]: Orthogonalize vector block-by-block
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: ORT\_FABULOUS\_BLOCK}}
}{}
\item[Default]: 0
\end{description}
\item [ICNTL(56)\label{itm:icntl56}]: Choose stopping criterion for the Conjugate Gradient iterative solver. Ignored if CG is not used. By default, we use the normwise backward error based on scaled residual. If you choose to use the lower bound of the A-norm of the error, you can set \ref{itm:icntl57} to control how many additionnal iterations will be performed to get a correct value of the A-norm error.
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: ICNTL\_CG\_StopCritNormA}}
}{}
\begin{description}
\item [1]: Use normwise backward error based on scaled residual.
\item [2]: Use lower bound of the A-norm of the error.
\item[Default]: 1
\end{description}
\item [ICNTL(57)\label{itm:icntl57}]: When \ref{itm:icntl56} = 2, additionnal iterations must be made to compute correctly the A-norm of the error. The parameter controls this number of additionnal iterations.
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: ICNTL\_CG\_StopCritNormA\_delay}}
}{}
\begin{description}
\item[Default]: 5
\end{description}
\item [ICNTL(60)\label{itm:icntl60}]: Keep the preconditioner when multiple driver calls with job = 6. Usefull for non linear simulation cases, e.g. when the matrix changes between temporal iterations. The user can also specify a frequency to recompute the preconditioner through \ref{itm:icntl61}. Only available with subdomain distributed intput or with restart from previous dump.
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: ICNTL\_MULTISOLVE\_PCD\_KEEP}}
}{}
\begin{description}
\item [0]: Do not keep the preconditioner
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: MULTISOLVE\_PCD\_DONTKEEP}}
}{}
\item [1]: Keep the preconditioner, recompute it every \ref{itm:icntl61} calls to the driver with job = 6.
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: MULTISOLVE\_PCD\_KEEP}}
}{}
\item[Default]: 0
\end{description}
\item [ICNTL(61)\label{itm:icntl61}]: Frequency to recompute the preconditioner when \ref{itm:icntl60} = 1
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: ICNTL\_MULTISOLVE\_PCD\_RECOMP}}
}{}
\begin{description}
\item [0]: Never recompute the preconditioner
\item [N $>0$]: Recompute the preconditioner each N iteration(s)
\item[Default]: 0
\end{description}
\item [ICNTL(62)\label{itm:icntl62}]: Control MUMPS's ICNTL of 7: the ordering tool (scotch/metis/pord...)
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: ICNTL\_MUMPS\_ORDERING}}
}{}
\begin{description}
\item[Default]: 5
\end{description}
\end{description}
\subsection{RCNTL}
\textbf{mphs\%RCNTL} is an integer array of size \textbf{MAPHYS\_RCNTL\_SIZE}.
\begin{description}
\item [RCNTL(2)\label{itm:rcntl2}]: is the target for \fabulous Deflated Restart algorithm. At each restart, the eigen vectors closest to this target will be kept. To set the number of vectors to keep, see \ref{itm:icntl48}.
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: RCNTL\_FABULOUS\_DR\_target}}
}{}
\begin{description}
\item[Default]: 0.0
\end{description}
\item [RCNTL(3)\label{itm:rcntl3}]: sets the value of $\alpha$ for custom stopping criteria of GMRes and CG (\ref{itm:icntl28} = 2). See section 2.5 of the GMRes documentation \cite{frgg:97} for more details.
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: RCNTL\_ITS\_stop\_alpha}}
}{}
\begin{description}
\item[Default]: 0
\end{description}
\item [RCNTL(4)\label{itm:rcntl4}]: sets the value of $\beta$ for custom stopping criteria of GMRes and CG (\ref{itm:icntl28} = 2). See section 2.5 of the GMRes documentation \cite{frgg:97} for more details.
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: RCNTL\_ITS\_stop\_beta}}
}{}
\begin{description}
\item[Default]: 0
\end{description}
\item [RCNTL(5)\label{itm:rcntl5}]: When \mumps error indicates that requires more memory workspace, if \ref{itm:icntl50} is set to -1, \maphys will try to call \mumps again by adding workspace. This values gives the amount by which the extra workspace (initially given by \ref{itm:icntl47}) will be multiplied for the next try. This value must be strictly greater than 1.
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: RCNTL\_MUMPS\_WS\_mult}}
}{}
\begin{description}
\item[Default]: 2.0
\end{description}
\item [RCNTL(8)\label{itm:rcntl8}]: Specifies the threshold used to sparsify the LU factors while using PILUT. Namely, all entries (i,j) of the U part such as: $|U(i,j)| / ( |U(i,i)|) \leq$ \ref{itm:rcntl8} are deleted. It is only relevant and must be set by the user before the factorisation step while using PILUT. See also: \ref{itm:icntl30}, \ref{itm:icntl8}, \ref{itm:icntl9} and \ref{itm:rcntl9}.
\\ \textbf{Warning: The default value is a bad value.}
\\ \textit{Note: For more details on ILU method, you may refer to Section \ref{sec:ilut}.}
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: RCNTL\_ILU\_LUThreshold}}
}{}
\begin{description}
\item[Default]: 0.0
\end{description}
\item [RCNTL(9)\label{itm:rcntl9}]: Specifies the threshold used to sparsify the schur complement while computing it with PILUT. Namely, all entries (i,j) of the schur S such as: $|S(i,j)| / ( |S(i,i)|) \leq$ \ref{itm:rcntl9} are deleted. It is only relevant and must be set by the user before the factorisation step while using PILUT. See also \ref{itm:icntl30}, \ref{itm:icntl8}, \ref{itm:icntl9} and \ref{itm:rcntl9}.
\\ \textbf{Warning: The default value is a bad value.}
\\ \textit{Note: For more details on ILU method, you may refer to Section \ref{sec:ilut}.}
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: RCNTL\_ILU\_SCHURThreshold}}
}{}
\begin{description}
\item[Default]: 0.0
\end{description}
\item [RCNTL(11)\label{itm:rcntl11}]: Specifies the threshold used to sparsify the Schur complement while computing a sparse preconditioner. It is only useful while selecting a sparse preconditioner. ( \ref{itm:icntl21} = 2 or 3 ). It must be above 0. All entries (i,j) of the assembled schur S such as: $|S(i,j)| / ( |S(i,i)| + |S(j,j)| ) \leq$  \ref{itm:rcntl11} are deleted.
\\ \textit{Note: For more details on dropping strategy (\ref{itm:icntl21} = 2 or 3), you may refer to Section \ref{dropstrat}.}
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: RCNTL\_PCD\_SparsifyThreshold}}
}{}
\begin{description}
\item[Default]: 1e-4
\end{description}
\iftoggle{devversion}{
\textcolor{red}{
\item [RCNTL(12)\label{itm:rcntl12}]: If the preconditonner is the sum of global and local precond, (\ref{itm:icntl21}=7), it specifies the threshold used to sparsify the global part of the preconditioner. All entries (i,j) of the assembled schur such as: $|S(i, j)|/(|S(i, i)| + |S(j, j)|) \leq $ \ref{itm:rcntl11} are deleted.
\\ \*\emph{Enumeration: RCNTL\_PCD\_SecondSparsifyThreshold}\begin{description}
\item[Default]: 0.01
\end{description}
}
}{}
\item [RCNTL(15)\label{itm:rcntl15}]: Specifies the imbalance tolerance used in Scotch partitionner to create the subdomains. The higher this parameter, the more Scotch will allow to have imbalance between domains in order to reduce the size of interface (and therefore the size of the Schur).
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: RCNTL\_Imbalance\_Rate}}
}{}
\begin{description}
\item[Default]: 0.2
\end{description}
\item [RCNTL(21)\label{itm:rcntl21}]: Specifies the threshold $\tau$ for the stopping criterion within the iterative solve step so that $\frac{|| A.x - b ||_2}{ ||b||_2} \leq \tau$. It must be above 0. Note that the iterative solver actually ensures that $\frac{|| S.x_{\Gamma} - b_{\Gamma} ||_2}{ ||b||_2} \leq \tau$. Because the solution computed on the interiors ($x_I$) is computed with a direct solver, we shall have $|| S.x - b_{\Gamma} ||_2 = || A.x - b ||_2$ (at least in exact arithmetics), hence, $\frac{|| S.x_{\Gamma} - b_{\Gamma} ||_2}{ ||b||_2} \leq \tau$ shall be equivalent to $\frac{|| A.x - b ||_2}{ ||b||_2} \leq \tau$ (at least in exact arithmetics). Note that \maphys{} also explicitly computes $\frac{|| A.x - b ||_2}{ ||b||_2}$ after the solve step (see \ref{itm:rinfog4} and \ref{itm:rinfog2}).
\\ \textbf{Warning: Ignored if \fabulous is used and mphs\%tolerances is set.}
\iftoggle{devversion}{
\textcolor{red}{
\\ \*\emph{Enumeration: RCNTL\_ITS\_Tolerance}}
}{}
\begin{description}
\item[Default]: 1e-05
\end{description}
\end{description}
